unit Unit1;

interface
// This is meant to be an example on how to implement a Graphic Equalizer
// to an audio player via a DSP Callback Function. In order this source code
// to work, the BASS 2.4 playback library is required. You can find the
// latest BASS version at http://www.un4seen.com.
// This source was developed with Turbo Delphi 2006 but i think it should work and
// with other versions of Delphi since it doesn't use any special syntax. 
// The reason that i'm releasing the source code is that i couldn't find
// equalizer source code for my audio player at the internet and so i thought
// it would be very useful to everyone.
// Everything that concerns the equalizer is at the EQFilters.pas unit.
// This code is free for any use. Do with it anything you want.
// But i will be very happy if you improve it and send me an e-mail
// with the corrections you made so that i will be able to use it in my programs.
// Note this please:
// This software is provided "as-is," without any express or implied warranty.
// In no event shall the author be held liable for any damages arising from the
// use of this software.
// Copyright (c) 2002-2008, George Boudouris
// E-mail: georgebou@hotmail.com
// HomePage: http://www.passionplayer.com
// This is also the homepage of my audio player, Passion Audio Player

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, BASS, EQFilters, ExtCtrls;

type
  TForm1 = class(TForm)
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    ScrollBar3: TScrollBar;
    ScrollBar4: TScrollBar;
    ScrollBar5: TScrollBar;
    ScrollBar6: TScrollBar;
    ScrollBar7: TScrollBar;
    ScrollBar8: TScrollBar;
    ScrollBar9: TScrollBar;
    ScrollBar10: TScrollBar;
    ScrollBar11: TScrollBar;
    Button3: TButton;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    CheckBox1: TCheckBox;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Timer1: TTimer;
    Label25: TLabel;
    ScrollBar12: TScrollBar;
    Label26: TLabel;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    ScrollBar13: TScrollBar;
    Label27: TLabel;
    Label28: TLabel;
    ScrollBar14: TScrollBar;
    CheckBox4: TCheckBox;
    Label29: TLabel;
    Label30: TLabel;
    ScrollBar15: TScrollBar;
    ScrollBar16: TScrollBar;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    CheckBox5: TCheckBox;
    procedure ScrollBarChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ScrollBar12Change(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure ScrollBar13Change(Sender: TObject);
    procedure ScrollBar14Change(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure ScrollBar15Change(Sender: TObject);
    procedure ScrollBar16Change(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
  private
    { Private declarations }
    chan: DWORD;
    procedure Error(msg: string);
  public
    { Public declarations }
    Procedure CreateEQLabels;
    Procedure UpdateEQLabelsValues;
  end;

var
  Form1: TForm1;

  DSPHandle_EQ: HDSP;              // DSP handle for EQ
  DSPHandle_ECHO: HDSP;            // DSP handle for Echo
  DSPHandle_ECHO1: HDSP;            // DSP handle for Echo1
  DSPHandle_REVERB: HDSP;          // DSP handle for Reverb

//  Echo Effect Variables
Const
     ECHBUFLEN = 11200;        // buffer length
Var
   echbuf:Array[0..ECHBUFLEN] Of TwoChannelsBuffer;
   echpos:Integer;

//  Echo Effect Variables
Const
     ECHO_Delay_Size=2*SampleRate; //SampleRate=1sec=1000msec delay
Var
   ECHO_Delay_Buffer:Array[0..ECHO_Delay_Size] Of TwoChannelsBuffer;
   ECHO_delay_time:Integer;
   ECHO_decay:Real; // Values between 0 and 1;
   ECHO_i:Integer;

// Reverb Effect Variables
Const
     REVERB_Delay_Size=2*SampleRate; //SampleRate=1sec=1000msec delay
     REVERB_MAX_COMB_FILTERS=6;
Var
   REVERB_delays:Array[0..REVERB_MAX_COMB_FILTERS-1] Of Integer; // delays for the comb filters
                                                                 // Values should be (between 0ms and 50ms).
   REVERB_delay_times:Array[0..REVERB_MAX_COMB_FILTERS-1] Of Integer;
   REVERB_decays:Array[0..REVERB_MAX_COMB_FILTERS-1] Of Real; // These are the decay values for each filter:Values between 0 and 1;
   REVERB_Delay_Buffer:Array[0..REVERB_Delay_Size] Of TwoChannelsBuffer;
   REVERB_decay:Real; // This is the effect decay:Values between 0 and 1;
   REVERB_delay_time:Integer;
   REVERB_i:Integer;


   REVERB_Time_T:Integer; // Reverb time T
//   T = -3*delay/(log decay)
//   (log decay) = -3*delay/T ;
//   (decay) =10^(-3*delay/T);




// Automatic Gain Structures and Variables
Var
   DSPHandle_AutoAmp: HDSP;          // DSP handle for AutoAmp

Const
     amptarget=20000; // target level
     ampquiet=800;    // quiet level
     amprate=0.02; // amp adjustment rate

Type
    AUTOAMPSTUFF = Record
                  gain:Double;   // amplification level
                  delay:Integer; // delay before increasing level
                  count:Integer; // count of sequential samples below target level
                  high:Integer;  // the highest in that period
                  quiet:Integer; // count of sequential samples below quiet level
    End;

Var
    amp:AUTOAMPSTUFF;


implementation

{$R *.dfm}

procedure TForm1.Error(msg: string);
var
  s: string;
begin
  s := msg + #13#10 + '(error code: ' + IntToStr(BASS_ErrorGetCode) + ')';
  MessageBox(handle, PChar(s), 'Error', MB_ICONERROR or MB_OK);
end;

Function ConvertMSecsToSamples(InputMSecs:Integer):Integer;
Var
   Samples:Integer;
Begin
     Samples:=InputMSecs*SampleRate div 1000;
     ConvertMSecsToSamples:=Samples;
End;

Function ConvertSamplesToMSecs(InputSamples:Integer):Integer;
Var
   MSecs:Integer;
Begin
     MSecs:=InputSamples*1000 Div SampleRate;
     ConvertSamplesToMSecs:=MSecs;
End;


Procedure TForm1.CreateEQLabels;
Begin
     Label12.Caption:=CurrToStr(CurrentEQBandsFrequencies[0]);
     Label13.Caption:=CurrToStr(CurrentEQBandsFrequencies[1]);
     Label14.Caption:=CurrToStr(CurrentEQBandsFrequencies[2]);
     Label15.Caption:=CurrToStr(CurrentEQBandsFrequencies[3]);
     Label16.Caption:=CurrToStr(CurrentEQBandsFrequencies[4]);
     Label17.Caption:=CurrToStr(CurrentEQBandsFrequencies[5]);
     Label18.Caption:=CurrToStr(CurrentEQBandsFrequencies[6]);
     Label19.Caption:=CurrToStr(CurrentEQBandsFrequencies[7]);
     Label20.Caption:=CurrToStr(CurrentEQBandsFrequencies[8]);
     Label21.Caption:=CurrToStr(CurrentEQBandsFrequencies[9]);
     Label22.Caption:='Amplify Signal';
End;

Procedure TForm1.UpdateEQLabelsValues;
Begin
     Label1.Caption :=IntToStr(-ScrollBar1.Position);
     Label2.Caption :=IntToStr(-ScrollBar2.Position);
     Label3.Caption :=IntToStr(-ScrollBar3.Position);
     Label4.Caption :=IntToStr(-ScrollBar4.Position);
     Label5.Caption :=IntToStr(-ScrollBar5.Position);
     Label6.Caption :=IntToStr(-ScrollBar6.Position);
     Label7.Caption :=IntToStr(-ScrollBar7.Position);
     Label8.Caption :=IntToStr(-ScrollBar8.Position);
     Label9.Caption :=IntToStr(-ScrollBar9.Position);
     Label10.Caption:=IntToStr(-ScrollBar10.Position);

     Label11.Caption:=IntToStr(-ScrollBar11.Position);
End;

Procedure UpdateEqualizerFunction;
var
  Counter:ShortInt;
   Multiplier:Integer;
begin
     SetCoefficientsForEQBand(0,CurrentEQFilter,1.4,-Form1.ScrollBar1.Position);
     SetCoefficientsForEQBand(1,CurrentEQFilter,1.4,-Form1.ScrollBar2.Position);
     SetCoefficientsForEQBand(2,CurrentEQFilter,1.4,-Form1.ScrollBar3.Position);
     SetCoefficientsForEQBand(3,CurrentEQFilter,1.4,-Form1.ScrollBar4.Position);
     SetCoefficientsForEQBand(4,CurrentEQFilter,1.4,-Form1.ScrollBar5.Position);
     SetCoefficientsForEQBand(5,CurrentEQFilter,1.4,-Form1.ScrollBar6.Position);
     SetCoefficientsForEQBand(6,CurrentEQFilter,1.4,-Form1.ScrollBar7.Position);
     SetCoefficientsForEQBand(7,CurrentEQFilter,1.4,-Form1.ScrollBar8.Position);
     SetCoefficientsForEQBand(8,CurrentEQFilter,1.4,-Form1.ScrollBar9.Position);
     SetCoefficientsForEQBand(9,CurrentEQFilter,1.4,-Form1.ScrollBar10.Position);

     Multiplier:=5;
     If Form1.ScrollBar11.Position<0 Then
        CalcTotalCoefficientsForAllBands(1+(-Form1.ScrollBar11.Position/Form1.ScrollBar11.Max*(Multiplier-1)))
     Else
         CalcTotalCoefficientsForAllBands(1-((Form1.ScrollBar11.Position/Form1.ScrollBar11.Max)*((Multiplier-1)/Multiplier)));
end;

// Notes:
// This DSP proc can take alot of optimizations but it was designed this way because
// if you want to change the Default EQ filters with your filters the only thing
// you have to do is to change the following line at the DSP Proc
// GetFilteredSample:=BandPassFilterOptimized(InputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-1],
//                                            InputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-2],
//                                            InputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-3],
//                                            OutputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-1],
//                                            OutputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-2]);
// with this new one:
// GetFilteredSample:=NewFilteringProc(InputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-1],
//                                     InputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-2],
//                                     InputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-3],
//                                     OutputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-1],
//                                     OutputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-2]);
// where NewFilteringProc is the new filtering function !!!!!!!!!!!!!!!!!

procedure EQ10BandsDSPProc (handle: HDSP; channel: DWORD; buffer: Pointer; length: DWORD; user: Pointer); stdcall;

var
   Lc, Rc: SmallInt;
   LcIn, RcIn: SmallInt;
   GetFilteredSample:TwoChannelsBuffer;
   Counter:Integer;
   DSPBufferPointer: StereoBufferPointer;
begin
     DSPBufferPointer := buffer;
     while (length > 0) do begin
           // Shift Samples in Input Buffer on position to left and
           // set the new value to the last one
           For Counter:=0 To NumberOfSamplesNeededToBufferForFilter-1-1 Do Begin
               InputBufferForEffect[Counter].Left:=InputBufferForEffect[Counter+1].Left;
               InputBufferForEffect[Counter].Right:=InputBufferForEffect[Counter+1].Right;
           End;
           // Set New Sample To the last position of the Input Buffer
           LcIn:=LOWORD(DSPBufferPointer^);
           RcIn:=HIWORD(DSPBufferPointer^);
           InputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-1].Left:=LcIn;  //Left Channel Sample
           InputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-1].Right:=RcIn; //Right Channel Sample

           // Get Filtered Sample
           GetFilteredSample:=BandPassFilterOptimized(InputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-1],
                                                      InputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-2],
                                                      InputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-3],
                                                      OutputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-1],
                                                      OutputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-2]);

           // Shift Samples in Input Buffer on position to left and
           // set the new value to the last one
           For Counter:=0 To NumberOfSamplesNeededToBufferForFilter-1-1 Do Begin
               OutputBufferForEffect[Counter].Left:=OutputBufferForEffect[Counter+1].Left;
               OutputBufferForEffect[Counter].Right:=OutputBufferForEffect[Counter+1].Right;
           End;
           // Set New Sample To the last position of the Input Buffer
           OutputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-1].Left:=GetFilteredSample.Left;
           OutputBufferForEffect[NumberOfSamplesNeededToBufferForFilter-1].Right:=GetFilteredSample.Right;

           // Update Output Buffer
           lc := SmallInt(Trunc(GetFilteredSample.Left)); //Left Channel Sample
           rc := SmallInt(Trunc(GetFilteredSample.Right)); //Right Channel Sample
           DSPBufferPointer^ := MakeLong(lc, rc);
           // Move Pointer to Show To Next Sample
           Inc(DSPBufferPointer);
           length := length - 4;
     end;
end;


// This DSP procedure is the base for all time delay effects
procedure DSPProc_ECHO(handle: HDSP; channel: DWORD; buffer: Pointer; length: DWORD; user: Pointer); stdcall;


var
   Lc, Rc: SmallInt;
   LcIn, RcIn: SmallInt;
   GetFilteredSample:TwoChannelsBuffer;
   Counter:Integer;
   DSPBufferPointer: StereoBufferPointer;
begin
     DSPBufferPointer := buffer;
     while (length > 0) do begin
           // Set New Sample To the last position of the Input Buffer
           LcIn:=LOWORD(DSPBufferPointer^);
           RcIn:=HIWORD(DSPBufferPointer^);

           GetFilteredSample.Left :=LcIn + Round(echbuf[echpos].Left/2);
           GetFilteredSample.Right:=RcIn + Round(echbuf[echpos].Right/2);

           echbuf[echpos].Left := LcIn;
           echbuf[echpos].Right:= RcIn;

           // Update Output Buffer
           lc := SmallInt(Trunc(GetFilteredSample.Left)); //Left Channel Sample
           rc := SmallInt(Trunc(GetFilteredSample.Right)); //Right Channel Sample
           DSPBufferPointer^ := MakeLong(lc, rc);
           // Move Pointer to Show To Next Sample
           Inc(DSPBufferPointer);
           Inc(echpos);
           if (echpos = ECHBUFLEN) then echpos := 0;
           length := length - 4;
     end;
end;

// This DSP procedure is the base for all time delay effects
procedure DSPProc_ECHO1(handle: HDSP; channel: DWORD; buffer: Pointer; length: DWORD; user: Pointer); stdcall;
var
   Lc, Rc: SmallInt;
   LcIn, RcIn: SmallInt;
   GetFilteredSample:TwoChannelsBuffer;
   Counter:Integer;
   DSPBufferPointer: StereoBufferPointer;

   ECHO_j:Integer;
   ECHO_delay:Integer;
begin
     DSPBufferPointer := buffer;
     ECHO_delay:=ConvertMSecsToSamples(ECHO_delay_time);
     while (length > 0) do begin
           // Set New Sample To the last position of the Input Buffer
           LcIn:=LOWORD(DSPBufferPointer^);
           RcIn:=HIWORD(DSPBufferPointer^);

           if (ECHO_i >= ECHO_delay) then ECHO_j:=ECHO_i-ECHO_delay    // work out the buffer position
           else ECHO_j:=ECHO_i-ECHO_delay+ECHO_delay_size+1;
           // add the delayed sample to the input sample
           GetFilteredSample.Left :=LcIn + ECHO_delay_buffer[ECHO_j].Left*ECHO_decay;
           GetFilteredSample.Right:=RcIn + ECHO_delay_buffer[ECHO_j].Right*ECHO_decay;

           // Clip Samples
           GetFilteredSample.Left :=Clip(GetFilteredSample.Left );
           GetFilteredSample.Right:=Clip(GetFilteredSample.Right);

           // store the result in the delay buffer, and output
           ECHO_delay_buffer[ECHO_i].Left:= GetFilteredSample.Left;
           ECHO_delay_buffer[ECHO_i].Right:= GetFilteredSample.Right;

           // Update Output Buffer
           lc := SmallInt(Trunc(GetFilteredSample.Left)); //Left Channel Sample
           rc := SmallInt(Trunc(GetFilteredSample.Right)); //Right Channel Sample
           DSPBufferPointer^ := MakeLong(lc, rc);
           // Move Pointer to Show To Next Sample
           Inc(DSPBufferPointer);
           Inc(ECHO_i);
           If ECHO_i>ECHO_delay_size then ECHO_i:=0;
           length := length - 4;
     end;
end;

// This DSP procedure is the base for all time delay effects
procedure DSPProc_REVERB(handle: HDSP; channel: DWORD; buffer: Pointer; length: DWORD; user: Pointer); stdcall;
var
   Lc, Rc: SmallInt;
   LcIn, RcIn: SmallInt;
   GetFilteredSample:TwoChannelsBuffer;
   Counter:Integer;
   DSPBufferPointer: StereoBufferPointer;

   REVERB_j:Integer;
   REVERB_delay:Integer;
begin
     DSPBufferPointer := buffer;
     REVERB_delay:=ConvertMSecsToSamples(REVERB_delay_time);

     REVERB_delays[0]:=ConvertMSecsToSamples(REVERB_delay_times[0]);
     REVERB_delays[1]:=ConvertMSecsToSamples(REVERB_delay_times[1]);
     REVERB_delays[2]:=ConvertMSecsToSamples(REVERB_delay_times[2]);
     REVERB_delays[3]:=ConvertMSecsToSamples(REVERB_delay_times[3]);
     REVERB_delays[4]:=ConvertMSecsToSamples(REVERB_delay_times[4]);
     REVERB_delays[5]:=ConvertMSecsToSamples(REVERB_delay_times[5]);

     while (length > 0) do begin
           // Set New Sample To the last position of the Input Buffer
           LcIn:=LOWORD(DSPBufferPointer^);
           RcIn:=HIWORD(DSPBufferPointer^);

           if (REVERB_i >= REVERB_delay) then REVERB_j:=REVERB_i-REVERB_delay    // work out the buffer position
           else REVERB_j:=REVERB_i-REVERB_delay+REVERB_delay_size+1;

           // add the delayed sample to the input sample
           GetFilteredSample.Left :=                        REVERB_delay_buffer[REVERB_j+REVERB_Delays[0]].Left *REVERB_decays[0];
           GetFilteredSample.Right:=                        REVERB_delay_buffer[REVERB_j+REVERB_Delays[0]].Right*REVERB_decays[0];
           // add the delayed sample to the input sample
           GetFilteredSample.Left :=GetFilteredSample.Left +REVERB_delay_buffer[REVERB_j+REVERB_Delays[1]].Left *REVERB_decays[1];
           GetFilteredSample.Right:=GetFilteredSample.Right+REVERB_delay_buffer[REVERB_j+REVERB_Delays[1]].Right*REVERB_decays[1];
           // add the delayed sample to the input sample
           GetFilteredSample.Left :=GetFilteredSample.Left +REVERB_delay_buffer[REVERB_j+REVERB_Delays[2]].Left *REVERB_decays[2];
           GetFilteredSample.Right:=GetFilteredSample.Right+REVERB_delay_buffer[REVERB_j+REVERB_Delays[2]].Right*REVERB_decays[2];
           // add the delayed sample to the input sample
           GetFilteredSample.Left :=GetFilteredSample.Left +REVERB_delay_buffer[REVERB_j+REVERB_Delays[3]].Left *REVERB_decays[3];
           GetFilteredSample.Right:=GetFilteredSample.Right+REVERB_delay_buffer[REVERB_j+REVERB_Delays[3]].Right*REVERB_decays[3];
           // add the delayed sample to the input sample
           GetFilteredSample.Left :=GetFilteredSample.Left +REVERB_delay_buffer[REVERB_j+REVERB_Delays[4]].Left *REVERB_decays[4];
           GetFilteredSample.Right:=GetFilteredSample.Right+REVERB_delay_buffer[REVERB_j+REVERB_Delays[4]].Right*REVERB_decays[4];
           // add the delayed sample to the input sample
           GetFilteredSample.Left :=GetFilteredSample.Left +REVERB_delay_buffer[REVERB_j+REVERB_Delays[5]].Left *REVERB_decays[5];
           GetFilteredSample.Right:=GetFilteredSample.Right+REVERB_delay_buffer[REVERB_j+REVERB_Delays[5]].Right*REVERB_decays[5];

           // scale the sum and add to input
           GetFilteredSample.Left :=LcIn + GetFilteredSample.Left *REVERB_decay;
           GetFilteredSample.Right:=RcIn + GetFilteredSample.Right*REVERB_decay;

           // Clip Samples
           GetFilteredSample.Left :=Clip(GetFilteredSample.Left );
           GetFilteredSample.Right:=Clip(GetFilteredSample.Right);

           // store the result in the delay buffer, and output
           REVERB_delay_buffer[REVERB_i].Left:= GetFilteredSample.Left;
           REVERB_delay_buffer[REVERB_i].Right:= GetFilteredSample.Right;

           // Update Output Buffer
           lc := SmallInt(Trunc(GetFilteredSample.Left)); //Left Channel Sample
           rc := SmallInt(Trunc(GetFilteredSample.Right)); //Right Channel Sample
           DSPBufferPointer^ := MakeLong(lc, rc);
           // Move Pointer to Show To Next Sample
           Inc(DSPBufferPointer);
           Inc(REVERB_i);
           If REVERB_i>REVERB_delay_size then REVERB_i:=0;
           length := length - 4;
     end;
end;

Type
    DataArray=Array[0..40000] Of Smallint;
    PDataArray=^DataArray;

procedure DSPProc_AutoAmp(handle: HDSP; channel: DWORD; buffer: Pointer; length: DWORD; user: Pointer); stdcall;
//procedure autoamp(HDSP handle, DWORD channel, void *buffer, DWORD length, AUTOAMPSTUFF *amp) ;stdcall;
Var
   Data:PDataArray;
   c: DWORD;
   s:Integer;
   sa:Integer;
Begin
     data :=buffer;
     for c:=0 To length Div 2-1 Do Begin
           s:=Round(data[c]*amp.gain); // amplify sample
           sa:=abs(s);
           if (abs(data[c])<amp.quiet) Then
              Inc(amp.quiet) // sample is below quiet level
           else
               amp.quiet:=0;
           if (sa<amptarget) Then Begin
              // amplified level is below target
              if (sa>amp.high) Then amp.high:=sa;
                 Inc(amp.count);
                 if (amp.count=amp.delay) Then Begin
                    // been below target for a while
                    if (amp.quiet>amp.delay) Then // it's quiet, go back towards normal level
                       amp.gain:=amp.gain+10*amprate*(1-amp.gain)
                    else
                        amp.gain:=amp.gain+amprate*amptarget/amp.high; // increase amp
                       amp.high:=0;
                       amp.count:=0; // reset counts
                 End;
           End
           else Begin // amplified level is above target
                 if (s<-32768) Then
                    s:=-32768
                 else
                     if (s>32767) Then s:=32767;
                 amp.gain:=amp.gain-2*amprate*sa/amptarget; // decrease amp
                 amp.high:=0;
                 amp.count:=0;
           End;
           data[c]:=Smallint(s); // replace original sample with amplified version
     End;
End;




procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then begin
    DSPHandle_EQ:=BASS_ChannelSetDSP(chan, EQ10BandsDSPProc, 0,0);
  end
  else
      BASS_ChannelRemoveDSP(chan, DSPHandle_EQ);
end;

procedure TForm1.ScrollBarChange(Sender: TObject);
begin
     UpdateEqualizerFunction;
     UpdateEQLabelsValues;
end;

procedure TForm1.FormCreate(Sender: TObject);
Var
   Counter:Integer;
begin
     // Echo Setup
     ECHO_delay_time:=100; //100 msecs
     ECHO_decay:=0.5;

     // reverb setup
{     For Counter:=0 To REVERB_MAX_COMB_FILTERS-1 Do Begin
         REVERB_delay_times[Counter]:=6;
     End;}

     // Use "random" values for the delays so that the different
     // delayed samples are incoherent.
     REVERB_delay_times[0]:=20;     // Values should be (between 0ms and 50ms).
     REVERB_delay_times[1]:=30;   // Values should be (between 0ms and 50ms).
     REVERB_delay_times[2]:=34;   // Values should be (between 0ms and 50ms).
     REVERB_delay_times[3]:=25;   // Values should be (between 0ms and 50ms).
     REVERB_delay_times[4]:=30;   // Values should be (between 0ms and 50ms).
     REVERB_delay_times[5]:=20;   // Values should be (between 0ms and 50ms).

     REVERB_decays[0]:=0.60;
     REVERB_decays[1]:=0.63;
     REVERB_decays[2]:=0.61;
     REVERB_decays[3]:=0.62;
     REVERB_decays[4]:=0.61;
     REVERB_decays[5]:=0.64;

     REVERB_delay_time:=100; //100 msecs
     REVERB_decay:=0.5;

     CreateEQLabels;// Display the equalizer frequencies
     UpdateEQLabelsValues;

     // Set Equalizer Variables
     UpdateEqualizerFunction;

	   // check the correct BASS was loaded
	   if (HIWORD(BASS_GetVersion) <> BASSVERSION) then begin
		    MessageBox(0,'An incorrect version of BASS.DLL was loaded',0,MB_ICONERROR);
		    Halt;
     end;
     // setup output - default device, 44100hz, stereo, 16 bits, no syncs (not used)
      if not BASS_Init(1, SampleRate, 0, handle,0) then begin
         Error('Can''t initialize device');
         Halt;
      end
      else
          BASS_Start;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
     ScrollBar1.Position:=-14;
     ScrollBar2.Position:=-14;
     ScrollBar3.Position:=-14;
     ScrollBar4.Position:=-14;
     ScrollBar5.Position:=-14;
     ScrollBar6.Position:=-14;
     ScrollBar7.Position:=-14;
     ScrollBar8.Position:=-14;
     ScrollBar9.Position:=-14;
     ScrollBar10.Position:=-14;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
     ScrollBar1.Position:=0;
     ScrollBar2.Position:=0;
     ScrollBar3.Position:=0;
     ScrollBar4.Position:=0;
     ScrollBar5.Position:=0;
     ScrollBar6.Position:=0;
     ScrollBar7.Position:=0;
     ScrollBar8.Position:=0;
     ScrollBar9.Position:=0;
     ScrollBar10.Position:=0;
end;

procedure TForm1.RadioButton3Click(Sender: TObject);
begin
     ScrollBar1.Position:=14;
     ScrollBar2.Position:=14;
     ScrollBar3.Position:=14;
     ScrollBar4.Position:=14;
     ScrollBar5.Position:=14;
     ScrollBar6.Position:=14;
     ScrollBar7.Position:=14;
     ScrollBar8.Position:=14;
     ScrollBar9.Position:=14;
     ScrollBar10.Position:=14;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     BASS_Free();
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   SaveChannelInfo:BASS_CHANNELINFO;
   chattr: Integer;

begin
  if OpenDialog1.Execute then begin
     // free both MOD and stream, it must be one of them! :)
     BASS_MusicFree(chan);
     BASS_StreamFree(chan);
     chan := BASS_StreamCreateFile(FALSE, PChar(OpenDialog1.FileName), 0, 0, 0);
     if (chan = 0) then
        chan := BASS_MusicLoad(FALSE, PChar(OpenDialog1.FileName), 0, 0, BASS_MUSIC_LOOP or BASS_MUSIC_RAMP,0);
        if (chan = 0) then begin
           // not a WAV/MP3 or MOD
           Error('Can''t play the file');
           Exit;
        end;




  If BASS_ChannelGetInfo(chan,SaveChannelInfo)=True Then Begin
        // Check if the channel is mono or stereo
        ChAttr := SaveChannelInfo.chans;
        if chattr <> 2 then begin
           // not 16-bit stereo
           BASS_MusicFree(chan);
           BASS_StreamFree(chan);
           Error('16-bit stereo sources only');
           Exit;
        end;
     End;

    // setup DSPs on new channel
    CheckBox1Click(Sender);

    // play both MOD and stream, it must be one of them! :)
    BASS_ChannelPlay(chan, False);

  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
     Label24.Caption := FloatToStrF(BASS_GetCPU, ffFixed, 4, 1);
end;

procedure TForm1.ScrollBar12Change(Sender: TObject);
Var
   PitchVaLue:Integer;
begin
     PitchVaLue:=100100-ScrollBar12.Position;
     Label26.Caption:=CurrToStr(PitchValue);
     BASS_ChannelSetAttribute(chan, BASS_ATTRIB_FREQ , PitchVaLue);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
     if CheckBox2.Checked then begin
        FillChar(echbuf, SizeOf(echbuf), 0);
        echpos := 0;
        DSPHandle_ECHO:=BASS_ChannelSetDSP(chan, DSPProc_ECHO, Nil,0);
     end
     else
         BASS_ChannelRemoveDSP(chan, DSPHandle_ECHO);
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
     if CheckBox3.Checked then begin
        FillChar(REVERB_Delay_Buffer, SizeOf(REVERB_Delay_Buffer), 0);
        REVERB_i := 0;
        DSPHandle_REVERB:=BASS_ChannelSetDSP(chan, DSPProc_REVERB, 0, 0);
     end
     else
         BASS_ChannelRemoveDSP(chan, DSPHandle_REVERB);
end;

procedure TForm1.ScrollBar13Change(Sender: TObject);
begin
     ECHO_delay_time:=ScrollBar13.Position*20;// Max=1000 msec
     Label29.Caption:=IntToStr(ECHO_delay_time)+ ' msecs';
end;

procedure TForm1.ScrollBar14Change(Sender: TObject);
begin
     ECHO_Decay:=ScrollBar14.Position/100;
     Label30.Caption:=CurrToStr(ECHO_Decay);
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
     if CheckBox4.Checked then begin
        FillChar(ECHO_Delay_Buffer, SizeOf(ECHO_Delay_Buffer), 0);
        ECHO_i := 0;
        DSPHandle_ECHO1:=BASS_ChannelSetDSP(chan, DSPProc_ECHO1, 0,0);
     end
     else
         BASS_ChannelRemoveDSP(chan, DSPHandle_ECHO1);
end;

procedure TForm1.ScrollBar15Change(Sender: TObject);
begin
     REVERB_delay_time:=ScrollBar15.Position*20;// Max=1000 msec
     Label33.Caption:=IntToStr(REVERB_delay_time)+ ' msecs';
end;

procedure TForm1.ScrollBar16Change(Sender: TObject);
begin
     REVERB_Decay:=ScrollBar16.Position/100;
     Label34.Caption:=CurrToStr(REVERB_Decay);
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
     if CheckBox5.Checked then begin
        amp.gain:=1;
        amp.delay:=BASS_ChannelSeconds2Bytes(handle,1) Div 2;
        amp.count:=0;
        amp.high :=0;
        amp.quiet:=0;
        // BASS_ChannelSetDSP(handle,(DSPPROC*)&autoamp,&amp);
        DSPHandle_AutoAmp:=BASS_ChannelSetDSP(chan, DSPProc_AutoAmp, 0,0);
     end
     else Begin
          BASS_ChannelRemoveDSP(chan, DSPHandle_AutoAmp);
     end;
end;

end.


